/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Contents of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.20 - (show annotations) (download)
Sun Jan 23 20:47:42 2005 UTC (9 years, 2 months ago) by eradicator
Branch: MAIN
Changes since 1.19: +5 -10 lines
Correct ARCH setting on sparc64.

1 # Copyright 1999-2004 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.19 2005/01/18 21:38:59 johnm Exp $
4 #
5 # Description: This eclass is used as a central eclass for accessing kernel
6 # related information for sources already installed.
7 # It is vital for linux-mod to function correctly, and is split
8 # out so that any ebuild behaviour "templates" are abstracted out
9 # using additional eclasses.
10 #
11 # Maintainer: John Mylchreest <johnm@gentoo.org>
12 # Copyright 2004 Gentoo Linux
13 #
14 # Please direct your bugs to the current eclass maintainer :)
15
16 # A Couple of env vars are available to effect usage of this eclass
17 # These are as follows:
18 #
19 # Env Var Option Description
20 # KERNEL_DIR <string> The directory containing kernel the target kernel
21 # sources.
22 # CONFIG_CHECK <string> a list of .config options to check for before
23 # proceeding with the install. ie: CONFIG_CHECK="MTRR"
24 # You can also check that an option doesn't exist by
25 # prepending it with an exclamation mark (!).
26 # ie: CONFIG_CHECK="!MTRR"
27 # <CFG>_ERROR <string> The error message to display when the above check
28 # fails. <CFG> should reference the appropriate option
29 # as above. ie: MTRR_ERROR="MTRR exists in the .config
30 # but shouldn't!!"
31 # KBUILD_OUTPUT <string> This is passed on commandline, or can be set from
32 # the kernel makefile. This contains the directory
33 # which is to be used as the kernel object directory.
34
35 # There are also a couple of variables which are set by this, and shouldn't be
36 # set by hand. These are as follows:
37 #
38 # Env Var Option Description
39 # KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1
40 # KV_MAJOR <integer> The kernel major version. ie: 2
41 # KV_MINOR <integer> The kernel minor version. ie: 6
42 # KV_PATCH <integer> The kernel patch version. ie: 9
43 # KV_EXTRA <string> The kernel EXTRAVERSION. ie: -gentoo
44 # KV_LOCAL <string> The kernel LOCALVERSION concatenation. ie: -johnm
45 # KV_DIR <string> The kernel source directory, will be null if
46 # KERNEL_DIR is invalid.
47 # KV_OUT_DIR <string> The kernel object directory. will be KV_DIR unless
48 # koutput is used. This should be used for referencing
49 # .config.
50
51
52 ECLASS=linux-info
53 INHERITED="$INHERITED $ECLASS"
54 EXPORT_FUNCTIONS pkg_setup
55
56 inherit toolchain-funcs
57
58 # Overwritable environment Var's
59 # ---------------------------------------
60 KERNEL_DIR="${KERNEL_DIR:-/usr/src/linux}"
61
62
63 # Bug fixes
64
65 # fix to bug #75034
66 case ${ARCH} in
67 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
68 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
69 esac
70
71 # Pulled from eutils as it might be more useful only being here since
72 # very few ebuilds which dont use this eclass will ever ever use these functions
73 set_arch_to_kernel() {
74 export ARCH="$(tc-arch-kernel)"
75 }
76
77 # set's ARCH back to what portage expects
78 set_arch_to_portage() {
79 export ARCH="$(tc-arch)"
80 }
81
82
83 #
84 # qeinfo "Message"
85 # -------------------
86 # qeinfo is a queit einfo call when EBUILD_PHASE
87 # should not have visible output.
88 #
89 qeinfo() {
90 local outputmsg
91 outputmsg="${@}"
92 case "${EBUILD_PHASE}" in
93 depend) unset outputmsg;;
94 clean) unset outputmsg;;
95 preinst) unset outputmsg;;
96 esac
97 [ -n "${outputmsg}" ] && einfo "${outputmsg}"
98 }
99
100 qeerror() {
101 local outputmsg
102 outputmsg="${@}"
103 case "${EBUILD_PHASE}" in
104 depend) unset outputmsg;;
105 clean) unset outputmsg;;
106 preinst) unset outputmsg;;
107 esac
108 [ -n "${outputmsg}" ] && einfo "${outputmsg}"
109 }
110
111
112
113 # File Functions
114 # ---------------------------------------
115
116 # getfilevar accepts 2 vars as follows:
117 # getfilevar <VARIABLE> <CONFIGFILE>
118
119 getfilevar() {
120 local ERROR workingdir basefname basedname xarch
121 ERROR=0
122
123 [ -z "${1}" ] && ERROR=1
124 [ ! -f "${2}" ] && ERROR=1
125
126 if [ "${ERROR}" = 1 ]
127 then
128 ebeep
129 echo -e "\n"
130 eerror "getfilevar requires 2 variables, with the second a valid file."
131 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
132 else
133 workingdir=${PWD}
134 basefname=$(basename ${2})
135 basedname=$(dirname ${2})
136 xarch=${ARCH}
137 unset ARCH
138
139 cd ${basedname}
140 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
141 make ${BUILD_FIXES} -f - e 2>/dev/null
142 cd ${workingdir}
143
144 ARCH=${xarch}
145 fi
146 }
147
148 linux_chkconfig_present() {
149 local RESULT
150 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
151 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
152 }
153
154 linux_chkconfig_module() {
155 local RESULT
156 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
157 [ "${RESULT}" = "m" ] && return 0 || return 1
158 }
159
160 linux_chkconfig_builtin() {
161 local RESULT
162 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
163 [ "${RESULT}" = "y" ] && return 0 || return 1
164 }
165
166 linux_chkconfig_string() {
167 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config"
168 }
169
170 # Versioning Functions
171 # ---------------------------------------
172
173 # kernel_is returns true when the version is the same as the passed version
174 #
175 # For Example where KV = 2.6.9
176 # kernel_is 2 4 returns false
177 # kernel_is 2 returns true
178 # kernel_is 2 6 returns true
179 # kernel_is 2 6 8 returns false
180 # kernel_is 2 6 9 returns true
181 #
182 # got the jist yet?
183
184 kernel_is() {
185 # if we haven't determined the version yet, we need too.
186 get_version;
187
188 local RESULT operator test value i len
189 RESULT=0
190
191 operator="="
192 if [ "${1}" == "lt" ]
193 then
194 operator="-lt"
195 shift
196 elif [ "${1}" == "gt" ]
197 then
198 operator="-gt"
199 shift
200 elif [ "${1}" == "le" ]
201 then
202 operator="-le"
203 shift
204 elif [ "${1}" == "ge" ]
205 then
206 operator="-ge"
207 shift
208 fi
209
210 if [ -n "${1}" ]
211 then
212 value="${value}${1}"
213 test="${test}${KV_MAJOR}"
214 fi
215 if [ -n "${2}" ]
216 then
217 len=$[ 3 - ${#2} ]
218 for((i=0; i<$len; i++)); do
219 value="${value}0"
220 done
221 value="${value}${2}"
222
223 len=$[ 3 - ${#KV_MINOR} ]
224 for((i=0; i<$len; i++)); do
225 test="${test}0"
226 done
227 test="${test}${KV_MINOR}"
228 fi
229 if [ -n "${3}" ]
230 then
231 len=$[ 3 - ${#3} ]
232 for((i=0; i<$len; i++)); do
233 value="${value}0"
234 done
235 value="${value}${3}"
236
237 len=$[ 3 - ${#KV_PATCH} ]
238 for((i=0; i<$len; i++)); do
239 test="${test}0"
240 done
241 test="${test}${KV_PATCH}"
242 fi
243
244 [ ${test} ${operator} ${value} ] && return 0 || return 1
245 }
246
247 get_version() {
248 local kbuild_output
249
250 # no need to execute this twice assuming KV_FULL is populated.
251 # we can force by unsetting KV_FULL
252 [ -n "${KV_FULL}" ] && return 0
253
254 # if we dont know KV_FULL, then we need too.
255 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
256 unset KV_DIR
257
258 # KV_DIR will contain the full path to the sources directory we should use
259 qeinfo "Determining the location of the kernel source code"
260 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
261 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
262
263 if [ -z "${KV_DIR}" ]
264 then
265 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
266 qeinfo "This package requires Linux sources."
267 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
268 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
269 qeinfo "(or the kernel you wish to build against)."
270 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
271 else
272 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
273 fi
274 return 1
275 fi
276
277 qeinfo "Found kernel source directory:"
278 qeinfo " ${KV_DIR}"
279
280 if [ ! -s "${KV_DIR}/Makefile" ]
281 then
282 qeerror "Could not find a Makefile in the kernel source directory."
283 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
284 return 1
285 fi
286
287 # OK so now we know our sources directory, but they might be using
288 # KBUILD_OUTPUT, and we need this for .config and localversions-*
289 # so we better find it eh?
290 # do we pass KBUILD_OUTPUT on the CLI?
291 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
292
293 # And if we didn't pass it, we can take a nosey in the Makefile
294 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)"
295 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
296
297 # And contrary to existing functions I feel we shouldn't trust the
298 # directory name to find version information as this seems insane.
299 # so we parse ${KV_DIR}/Makefile
300 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)"
301 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)"
302 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)"
303 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)"
304
305 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
306 then
307 qeerror "Could not detect kernel version."
308 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
309 return 1
310 fi
311
312 # and in newer versions we can also pull LOCALVERSION if it is set.
313 # but before we do this, we need to find if we use a different object directory.
314 # This *WILL* break if the user is using localversions, but we assume it was
315 # caught before this if they are.
316 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \
317 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}/build}"
318
319 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
320 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
321 if [ -n "${KV_OUT_DIR}" ];
322 then
323 qeinfo "Found kernel object directory:"
324 qeinfo " ${KV_OUT_DIR}"
325
326 KV_LOCAL="$(cat ${KV_OUT_DIR}/localversion* 2>/dev/null)"
327 fi
328 # and if we STILL haven't got it, then we better just set it to KV_DIR
329 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
330
331 KV_LOCAL="${KV_LOCAL}$(cat ${KV_DIR}/localversion* 2>/dev/null)"
332 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
333 KV_LOCAL="${KV_LOCAL//\"/}"
334
335 # And we should set KV_FULL to the full expanded version
336 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
337
338 qeinfo "Found sources for kernel version:"
339 qeinfo " ${KV_FULL}"
340
341 if [ ! -s "${KV_OUT_DIR}/.config" ]
342 then
343 qeerror "Could not find a usable .config in the kernel source directory."
344 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
345 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
346 qeerror "it points to the necessary object directory so that it might find .config."
347 return 1
348 fi
349
350 return 0
351 }
352
353
354
355
356 # ebuild check functions
357 # ---------------------------------------
358
359 check_kernel_built() {
360 # if we haven't determined the version yet, we need too.
361 get_version;
362
363 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
364 then
365 eerror "These sources have not yet been prepared."
366 eerror "We cannot build against an unprepared tree."
367 eerror "To resolve this, please type the following:"
368 eerror
369 eerror "# cd ${KV_DIR}"
370 eerror "# make oldconfig"
371 eerror "# make modules_prepare"
372 eerror
373 eerror "Then please try merging this module again."
374 die "Kernel sources need compiling first"
375 fi
376 }
377
378 check_modules_supported() {
379 # if we haven't determined the version yet, we need too.
380 get_version;
381
382 if ! linux_chkconfig_builtin "MODULES"
383 then
384 eerror "These sources do not support loading external modules."
385 eerror "to be able to use this module please enable \"Loadable modules support\""
386 eerror "in your kernel, recompile and then try merging this module again."
387 die "No support for external modules in ${KV_FULL} config"
388 fi
389 }
390
391 check_extra_config() {
392 local config negate error local_error i n temp_config
393
394 # if we haven't determined the version yet, we need too.
395 get_version;
396
397 einfo "Checking for suitable kernel configuration options"
398 for config in ${CONFIG_CHECK}
399 do
400 negate="${config:0:1}"
401 if [ "${negate}" == "!" ];
402 then
403 config="${config:1}"
404 if linux_chkconfig_present ${config}
405 then
406 local_error="${config}_ERROR"
407 local_error="${!local_error}"
408 [ -n "${local_error}" ] && eerror " ${local_error}" || \
409 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
410 error=1
411 fi
412 elif [ "${negate}" == "@" ];
413 then
414 # we never call this unless we are using MODULE_NAMES
415
416 config="${config:1}"
417 temp_config="${config//*:}"
418 config="${config//:*}"
419 if linux_chkconfig_present ${config}
420 then
421 local_error="${config}_ERROR"
422 local_error="${!local_error}"
423 [ -n "${local_error}" ] && eerror " ${local_error}" || \
424 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
425
426 for i in ${MODULE_NAMES}
427 do
428 n="${i//${temp_config}}"
429 [ -z "${n//(*}" ] && MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
430 done
431 error=0
432 fi
433 else
434 if ! linux_chkconfig_present ${config}
435 then
436 local_error="${config}_ERROR"
437 local_error="${!local_error}"
438 [ -n "${local_error}" ] && eerror " ${local_error}" || \
439 eerror " CONFIG_${config}:\tshould be set in the kernel configuration, but isn't"
440 error=1
441 fi
442 fi
443 done
444
445 if [ "${error}" == 1 ] ;
446 then
447 eerror "Please check to make sure these options are set correctly."
448 eerror "Once you have satisfied these options, please try merging"
449 eerror "this package again."
450 die "Incorrect kernel configuration options"
451 fi
452 }
453
454 check_zlibinflate() {
455 # if we haven't determined the version yet, we need too.
456 get_version;
457
458 # although I restructured this code - I really really really dont support it!
459
460 # bug #27882 - zlib routines are only linked into the kernel
461 # if something compiled into the kernel calls them
462 #
463 # plus, for the cloop module, it appears that there's no way
464 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS
465 # is on
466
467 local INFLATE
468 local DEFLATE
469
470 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
471
472 ebegin "checking ZLIB_INFLATE"
473 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config
474 eend $?
475 [ "$?" != 0 ] && die
476
477 ebegin "checking ZLIB_DEFLATE"
478 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config
479 eend $?
480 [ "$?" != 0 ] && die
481
482
483 local LINENO_START
484 local LINENO_END
485 local SYMBOLS
486 local x
487
488 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
489 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
490 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
491 (( LINENO_END = $LINENO_END - 1 ))
492 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
493
494 # okay, now we have a list of symbols
495 # we need to check each one in turn, to see whether it is set or not
496 for x in $SYMBOLS ; do
497 if [ "${!x}" = "y" ]; then
498 # we have a winner!
499 einfo "${x} ensures zlib is linked into your kernel - excellent"
500 return 0
501 fi
502 done
503
504 eerror
505 eerror "This kernel module requires ZLIB library support."
506 eerror "You have enabled zlib support in your kernel, but haven't enabled"
507 eerror "enabled any option that will ensure that zlib is linked into your"
508 eerror "kernel."
509 eerror
510 eerror "Please ensure that you enable at least one of these options:"
511 eerror
512
513 for x in $SYMBOLS ; do
514 eerror " * $x"
515 done
516
517 eerror
518 eerror "Please remember to recompile and install your kernel, and reboot"
519 eerror "into your new kernel before attempting to load this kernel module."
520
521 die "Kernel doesn't include zlib support"
522 }
523
524 ################################
525 # Default pkg_setup
526 # Also used when inheriting linux-mod to force a get_version call
527
528 linux-info_pkg_setup() {
529 get_version || die "Unable to calculate Linux Kernel version"
530 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
531 }

  ViewVC Help
Powered by ViewVC 1.1.20